"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapInArrayIterator = wrapInArrayIterator;

var _private = require("./private.js");

const _ = (0, _private.createPrivateStorage)();

const IteratorPrototype = Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]()));
const ArrayIteratorPrototype = Object.create(IteratorPrototype, {
  next: {
    value: function next() {
      return _(this).iterator.next();
    },
    writable: true,
    configurable: true
  },
  [Symbol.toStringTag]: {
    value: "Array Iterator",
    configurable: true
  }
});
/**
 * @param {Iterator<number>} iterator
 * @returns {IterableIterator<number>}
 */

function wrapInArrayIterator(iterator) {
  const arrayIterator = Object.create(ArrayIteratorPrototype);
  _(arrayIterator).iterator = iterator;
  return arrayIterator;
}