"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isDataView = isDataView;
exports.isSharedArrayBuffer = isSharedArrayBuffer;
exports.isIterable = isIterable;
exports.isCanonicalIntegerIndexString = isCanonicalIntegerIndexString;
Object.defineProperty(exports, "isObject", {
  enumerable: true,
  get: function () {
    return _isObject.default;
  }
});
Object.defineProperty(exports, "isArrayBuffer", {
  enumerable: true,
  get: function () {
    return _isArrayBuffer.default;
  }
});
Object.defineProperty(exports, "isTypedArray", {
  enumerable: true,
  get: function () {
    return _isTypedArray.default;
  }
});

var _isObject = _interopRequireDefault(require("lodash/isObject.js"));

var _isObjectLike = _interopRequireDefault(require("lodash/isObjectLike.js"));

var _spec = require("./spec.js");

var _isArrayBuffer = _interopRequireDefault(require("lodash/isArrayBuffer.js"));

var _isTypedArray = _interopRequireDefault(require("lodash/isTypedArray.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const toString = Object.prototype.toString;
/**
 * @param {unknown} value
 * @returns {boolean}
 */

function isDataView(value) {
  return ArrayBuffer.isView(value) && toString.call(value) === "[object DataView]";
}
/**
 * @param {unknown} value
 * @returns {boolean}
 */


function isSharedArrayBuffer(value) {
  return (0, _isObjectLike.default)(value) && toString.call(value) === "[object SharedArrayBuffer]";
}
/**
 * @param {unknown} value
 * @returns {boolean}
 */


function isIterable(value) {
  return (0, _isObject.default)(value) && typeof value[Symbol.iterator] === "function";
}
/**
 * @param {unknown} key
 * @returns {boolean}
 */


function isCanonicalIntegerIndexString(key) {
  return typeof key === "string" && key === (0, _spec.ToIntegerOrInfinity)(key) + "";
}